<script lang="ts">
  import type { UserProfileInfoById$result } from "$houdini";
  import { faExclamationCircle } from "@fortawesome/free-solid-svg-icons";
  import { Badge, Tooltip } from "flowbite-svelte";
  import Fa from "svelte-fa";

  type Award = UserProfileInfoById$result["awards_assertions"][0] & {
    // just trust me, bro 🗑️🔥
    badgr?: NonNullable<NonNullable<UserProfileInfoById$result["c2games_user_by_pk"]>["badges"]>[0];
  }

  export let award: Award;
</script>

<div class="w-64 text-center max-sm:w-full max-sm:mx-auto grid-rows-subgrid grid-cols-subgrid grid
                      p-5 border-2 rounded-lg shadow-md row-span-5">
  <!-- row - img -->
  {#if award.badgr}
      <img width="120px" height="120px" class="mx-auto" alt="{award.badgr.badge.name} Badge"
           src="{award.badgr.image_url}">
  {:else}
    <img width="120px" height="120px" class="mx-auto" alt="{award.badge.name} Badge"
         src="{award.badge.img_dark}">
  {/if}

  <!-- row - name -->
  <p class="font-bold text-xl">
    {award.badgr?.badge.name || award.badge.name}
  </p>

  <!-- row - issued on -->
  <div>
    <p class="text-sm font-bold">
      {#if award.badgr?.issued_on}
        {new Date(award.badgr.issued_on).toLocaleDateString(
          'en-US', { weekday: 'short', day: 'numeric', month: 'short' }
        )}
      {:else}
        {award.created.toLocaleDateString('en-US', { weekday: 'short', day: 'numeric', month: 'short' })}
      {/if}
    </p>

    <p>
      <a href="/user-dashboard/teams/{award.team_id}">{award.team?.long_name || 'View team'}</a>
    </p>
  </div>

  <!-- row - extra -->
  <div>
    {#if !award.badgr}
      <Badge color="yellow">unpublished</Badge>
      <Tooltip>This award has not been published to Badgr</Tooltip>
    {:else}
      {#if !award.badgr.accepted}
        <Badge color="green">Login to Badgr to accept this badge!</Badge>
      {/if}

      {#if award.badgr.revoked}
        <p class="text-red-600">
          <Fa class="inline-block" icon={faExclamationCircle} />
          This badge has been revoked
        </p>
      {/if}
    {/if}
  </div>

  <!-- row - narrative -->
  {#if award.badgr?.narrative}
    <p class="pt-1 px-3">{award.badgr.narrative}</p>
  {/if}
</div>
